#version 330

uniform float stepSize;
uniform sampler2D texThresholded;
smooth in vec2 fragmentUV;

out vec4 fragColor;

void main(void)
{
	vec4 upperPixel = texture(texThresholded, fragmentUV - vec2(0.0f, stepSize * 1.5));
	vec4 middlePixel = texture(texThresholded, fragmentUV);
	vec4 lowerPixel = texture(texThresholded, fragmentUV + vec2(0.0f, stepSize * 1.5));
	vec4 outPixel = vec4(0.0f, 0.0f, 0.0f, 0.0f);
	float coeff1 = 1.0f;
	float coeff2 = 0.5f;
	outPixel.x = coeff2 * upperPixel.x + coeff1 * middlePixel.x + coeff2 * lowerPixel.x;
	outPixel.y = coeff2 * upperPixel.y + coeff1 * middlePixel.y + coeff2 * lowerPixel.y;
	outPixel.z = coeff2 * upperPixel.z + coeff1 * middlePixel.z + coeff2 * lowerPixel.z;
	outPixel.w = middlePixel.w;
	fragColor = outPixel;
}
