#version 330

uniform mat4 projectionViewMatrix;
uniform vec3 eyePosition;

layout (points) in;
layout (triangle_strip) out;
layout (max_vertices = 4) out;

#define PARTICLE_WIDTH 0.5f
#define PARTICLE_HEIGHT 0.5f

in float geomAlpha[];

out vec2 uv;
out float fragAlpha;

void main()
{
	vec3 pos = gl_in[0].gl_Position.xyz;

	vec3 toCamera = normalize(eyePosition - pos);
	vec3 up = vec3(0.0, 1.0, 0.0);
	vec3 right = cross(toCamera, up);

	pos -= (right * 0.5 * PARTICLE_WIDTH);
	gl_Position = projectionViewMatrix * vec4(pos, 1.0);
	uv = vec2(0.0, 0.0);
	fragAlpha = geomAlpha[0];
	EmitVertex();
	
	pos.y += 1.0 * PARTICLE_HEIGHT;
	gl_Position = projectionViewMatrix * vec4(pos, 1.0);
	uv = vec2(0.0, 1.0);
	fragAlpha = geomAlpha[0];
	EmitVertex();
	
	pos.y -= 1.0 * PARTICLE_HEIGHT;
	pos += right * PARTICLE_WIDTH;
	gl_Position = projectionViewMatrix * vec4(pos, 1.0);
	uv = vec2(1.0, 0.0);
	fragAlpha = geomAlpha[0];
	EmitVertex();
	
	pos.y += 1.0 * PARTICLE_HEIGHT;
	gl_Position = projectionViewMatrix * vec4(pos, 1.0);
	uv = vec2(1.0, 1.0);
	fragAlpha = geomAlpha[0];
	EmitVertex();

	EndPrimitive();
}